## dpuser 4.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# set project name and version
project(QFitsView VERSION 4.2)

# specify the C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)

if (WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wa,-mbig-obj") 
endif()

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# control where the static and shared libraries are built so that on windows
# we don't need to tinker with the path to run the executable
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}")

# FLAGS
option(BUILD_SHARED_LIBS "Build using shared libraries" ON)

option(LBT "LBT" OFF)
option(HAS_VTK "has VTK" ON)
option(HAS_GDL "has GDL" OFF)
option(HAS_PYTHON "has Python" ON)
option(HAS_PLPLOT "has PLPlot" OFF)
option(HAS_PGPLOT "has PGPlot" ON)
option(HAS_DPPGPLOT "has DPPGPlot" ON)
option(HAS_PG2PLPLOT "has PG2PLPlot" OFF)

add_definitions(-DDPQT)
add_definitions(-DNO_READLINE)
# dpuser definitions are unused
set(DPUSER_DEFINITIONS -o QT=ON)

if(HAS_VTK)
  add_definitions(-DHAS_VTK)
  set(DPUSER_DEFINITIONS ${DPUSER_DEFINITIONS} -o HAS_VTK=ON)
endif()
if(HAS_GDL)
  add_definitions(-DHAS_GDL)
  include_directories("../include/gdl/")
  set(DPUSER_DEFINITIONS ${DPUSER_DEFINITIONS} -o HAS_GDL=ON)
endif()
if(HAS_PYTHON)
  add_definitions(-DHAS_PYTHON)
  set(DPUSER_DEFINITIONS ${DPUSER_DEFINITIONS} -o HAS_PYTHON=ON)
  if (WIN32)
    include_directories("../include/WIN/python/")
  elseif(APPLE)
    include_directories("../include/MACOSX/python/")
  else()
    include_directories("../include/LINUX/python/")
  endif()
endif()
if(HAS_PLPLOT)
  add_definitions(-DHAS_PLPLOT)
  set(DPUSER_DEFINITIONS ${DPUSER_DEFINITIONS} -o HAS_PLPOT=ON)
endif()
if(HAS_PGPLOT)
  add_definitions(-DHAS_PGPLOT)
  set(DPUSER_DEFINITIONS ${DPUSER_DEFINITIONS} -o HAS_PGPLOT=ON)
endif()
if(HAS_DPPGPLOT)
  add_definitions(-DHAS_DPPGPLOT)
  set(DPUSER_DEFINITIONS ${DPUSER_DEFINITIONS} -o HAS_DPPGPLOT=ON)
endif()
if(HAS_PG2PLPLOT)
  add_definitions(-DHAS_PG2PLPLOT)
  set(DPUSER_DEFINITIONS ${DPUSER_DEFINITIONS} -o HAS_P2PLPLOT=ON)
endif()

if (HAS_PGPLOT AND HAS_PG2PLPLOT)
  message("Both HAS_PGPLOT and HAS_PG2PLPLOT defined, thus DPPGPLOT must be undefined.")
  unset(HAS_DPPGPLOT)
  remove_definitions(-DHAS_DPPGPLOT)
endif()

if(WIN32)
  add_definitions(-DHAVE_MINGW32)
  add_definitions(-DWIN)
endif()

# Qt modules
if (NOT QT_PATH)
  if(WIN32)
    message("win32")
    get_filename_component(QT_PATH "/Qt" ABSOLUTE)
  elseif(APPLE)
    message("apple")
    get_filename_component(QT_PATH "/Users/ott/Qt/6.5.3/macos/lib/cmake/Qt6" ABSOLUTE)
  else()
    get_filename_component(QT_PATH "/home/ott/Qt/6.5.3/gcc_64/lib/cmake/Qt6" ABSOLUTE)
  endif()
  message("Looking for QT in ${QT_PATH}.")
endif()

set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${QT_PATH})

find_package(Qt6 COMPONENTS Network PrintSupport Svg DataVisualization REQUIRED)

# extra subdirectory
include_directories("extra/")

# QFitsBuffers subdirectory
include_directories("QFitsBuffers/")

# QFitsViews subdirectory
include_directories("QFitsViews/")

# QFitsWidgets subdirectory
include_directories("QFitsWidgets/")

# QCustomPlot subdirectory
include_directories("QCustomPlot/")

# Add dpuser as external project
#@include(ExternalProject)

get_filename_component(DPUSER_PATH "../dpuser/" ABSOLUTE)

# TODO: use dpuser as external project, do NOT compile it here
#ExternalProject_Add(dpuser
#                   SOURCE_DIR ${DPUSER_PATH}
#                   BINARY_DIR ${DPUSER_PATH}
#                   PREFIX ${DPUSER_PATH}
#                   CONFIGURE_COMMAND "${DPUSER_PATH}/setup" -b "${DPUSER_PATH}" -i "${DPUSER_PATH}/install-dpuser/" # ${DPUSER_DEFINITIONS}
#                   )

#@add_custom_command(
#@                  WORKING_DIRECTORY ${DPUSER_PATH}
#@                  COMMENT "Building dpuser..."
#@                  OUTPUT ${DPUSER_PATH}/doc/helpmap.cpp ${DPUSER_PATH}/mpfitScanner.cpp ${DPUSER_PATH}/mpfitParser.cpp #@${DPUSER_PATH}/astScanner.cpp ${DPUSER_PATH}/astParser.cpp
#@                  COMMAND ./setup
#@                  COMMAND cmake --build . --parallel # ${DPUSER_DEFINITIONS}
#@                  USES_TERMINAL
#@                  )

# BISON & FLEX - uncomment if modifying the parsers
#find_package(BISON 2.6)
#find_package(FLEX 2.5)

# mpfit subdirectory
IF(BISON_FOUND AND FLEX_FOUND)
  BISON_TARGET(mpfitParser ${DPUSER_PATH}/mpfit/mpfit.y "${CMAKE_CURRENT_BINARY_DIR}/mpfitParser.cpp" DEFINES_FILE "${CMAKE_CURRENT_BINARY_DIR}/mpfitParser.h")

  ADD_CUSTOM_TARGET(
     patchMpfitParser
     COMMAND ${CMAKE_COMMAND} -P "${DPUSER_PATH}/mpfit/patch_mpfit_parser.cmake"
     DEPENDS ${BISON_mpfitParser_OUTPUTS}
  )

  FLEX_TARGET(mpfitScanner ${DPUSER_PATH}/mpfit/mpfit.l "${CMAKE_CURRENT_BINARY_DIR}/mpfitScanner.cpp" COMPILE_FLAGS "-l")

  ADD_CUSTOM_TARGET(
     patchMpfitScanner
     COMMAND ${CMAKE_COMMAND} -P "${DPUSER_PATH}/mpfit/patch_mpfit_scanner.cmake"
     DEPENDS ${FLEX_mpfitScanner_OUTPUTS}
  )

  ADD_FLEX_BISON_DEPENDENCY(mpfitScanner mpfitParser)



# parser subdirectory
  BISON_TARGET(astParser ${DPUSER_PATH}/parser/ast.y "${CMAKE_CURRENT_BINARY_DIR}/astParser.cpp" DEFINES_FILE "${CMAKE_CURRENT_BINARY_DIR}/astParser.h")
FLEX_TARGET(astScanner ${DPUSER_PATH}/parser/ast.l "${CMAKE_CURRENT_BINARY_DIR}/astScanner.cpp"  COMPILE_FLAGS "-l")
ADD_FLEX_BISON_DEPENDENCY(astScanner astParser)
ENDIF()

# include dpuser codepath
include_directories("${DPUSER_PATH}")
include_directories("${DPUSER_PATH}/parser/")
include_directories("${DPUSER_PATH}/mpfit/")

set(DPUSER
   ${DPUSER_PATH}/arithmetics.cpp
   ${BISON_astParser_OUTPUTS}
   ${FLEX_astScanner_OUTPUTS}
   ${DPUSER_PATH}/boolean.cpp
   ${DPUSER_PATH}/dpuser.yacchelper.cpp
   ${DPUSER_PATH}/dpuser.input.cpp
   ${DPUSER_PATH}/dpuser_utils.cpp
   ${DPUSER_PATH}/dpuser.procs.cpp
   ${DPUSER_PATH}/dpuserType.cpp
   ${DPUSER_PATH}/dpuserAST.cpp
   ${DPUSER_PATH}/functions.cpp
   ${DPUSER_PATH}/gdl_dpuser.cpp
   ${DPUSER_PATH}/procedures.cpp
   ${DPUSER_PATH}/python_dpuser.cpp
   ${DPUSER_PATH}/doc/helpmap.cpp
   ${DPUSER_PATH}/mpfit/mpfitAST.cpp
   ${DPUSER_PATH}/parser/svn_revision.cpp
   )

IF(BISON_FOUND AND FLEX_FOUND)
set(DPUSER
   ${DPUSER}
   ${BISON_astParser_OUTPUTS}
   ${FLEX_astScanner_OUTPUTS}
   ${BISON_mpfitParser_OUTPUTS}
   ${FLEX_mpfitScanner_OUTPUTS}
)
ELSE()
set(DPUSER
   ${DPUSER}
   ${DPUSER_PATH}/parser/astScanner.cpp
   ${DPUSER_PATH}/parser/astParser.cpp
   ${DPUSER_PATH}/mpfit/mpfitScanner.cpp
   ${DPUSER_PATH}/mpfit/mpfitParser.cpp
)
ENDIF()


# other dependencies to include: libfits
include_directories("../libfits/")

set(LIBFITS
   ../libfits/3d_stuff.cpp
   ../libfits/cube.c
   ../libfits/dpheader.cpp
   ../libfits/fits.cpp
   ../libfits/fits_cube.cpp
   ../libfits/fits_dpl.cpp
   ../libfits/fits_exc.cpp
   ../libfits/fits_file.cpp
   ../libfits/fits_filters.cpp
   ../libfits/fits_funcs.cpp
   ../libfits/fits_mem.cpp
   ../libfits/fits_ops.cpp
   ../libfits/fits_procs.cpp
   ../libfits/fits_range.cpp
   ../libfits/fits_red.cpp
   ../libfits/JulianDay.cpp
   ../libfits/math_utils.cpp
   ../libfits/dpComplex.cpp
   ../libfits/fitting.cpp
   ../libfits/voronoi.cpp
   ../libfits/fits_logic.cpp
   ../libfits/astrolib.cpp
   )

# other dependencies to include: utils
include_directories("../utils/")
include_directories("../utils/kabsch/")
include_directories("../utils/cmpfit/")
include_directories("../utils/regex/")

set(UTILS
   ../utils/dpstring.cpp
   ../utils/dpstringlist.cpp
   ../utils/cpgplot.cpp
   ../utils/regex/regex_sr.cpp
   ../utils/cmpfit/mpfit.cpp
   ../utils/kabsch/kabsch2d.cpp
   )

if (HAS_PGPLOT AND HAS_DPPGPLOT)
  set(UTILS
     ${UTILS}
     ../utils/cpg3d.c
     )
endif()

# Additional settings and files
if (HAS_VTK)
  set(EXTRAS
     ${EXTRAS}
     "QFitsWidgets/QFitsWidget3D.cpp"
     "QFitsViews/QFitsView3D.cpp"
     )
endif()

if (LBT)
  set(EXTRAS
     ${EXTRAS}
     "lbt.cpp"
     )
endif()

foreach(file ${EXTRAS})
  message(STATUS "${file}")
endforeach()

# other dependencies to include: include
include_directories("../include/")

# build the executable: QFitsView
add_executable(QFitsView WIN32
              dialogs.cpp
              events.cpp
              galfit_control.ui
              galfit_gaussian.ui
              galfit_hidden.ui
              galfit_sersic.ui
              galfit_sky.ui
              galfit.cpp
              guitools.cpp
              highlighter.cpp
              imred.cpp
              lut.cpp
              main.cpp
              qt_mainwindow.cpp
              qt_mdichild.cpp
              qtdpuser.cpp
              QPgplot.cpp
              QFitsCubeSpectrum.cpp
              QFitsGlobal.cpp
              QFitsHeaderView.cpp
              QFitsMainWindow.cpp
              QFitsMainView.cpp
              QFitsMarkers.cpp
              QFitsPreferences.cpp
              QFitsToolBar.cpp
              QFitsTools.cpp
              QFitsViewingTools.cpp
              QFitsWedge.cpp
              RGBDialog.cpp
              # QFitsBuffers
              QFitsBuffers/QFitsBaseBuffer.cpp
              QFitsBuffers/QFitsSingleBuffer.cpp
              QFitsBuffers/QFitsMultiBuffer.cpp
              QFitsScroller.cpp
              # QFitsWidgets
              QFitsWidgets/QFitsBaseWidget.cpp
              QFitsWidgets/QFitsWidget1D.cpp
              QFitsWidgets/QFitsWidget2D.cpp
              QFitsWidgets/QFitsWidgetWiregrid.cpp
              QFitsWidgets/QFitsWidgetContour.cpp
              QFitsWidgets/QFitsWidgetTable.cpp
              # QFitsViews
              QFitsViews/QFitsBaseView.cpp
              QFitsViews/QFitsView1D.cpp
              QFitsViews/QFitsView2D.cpp
              # QCustomPlot
              QCustomPlot/qcustomplot.cpp
              # extra
              extra/tetrixboard.cpp
              extra/tetrixpiece.cpp
              extra/tetrixwindow.cpp
              # other dependencies
              ${DPUSER}
              ${LIBFITS}
              ${UTILS}
              # extras
              ${EXTRAS}
              # qrc
              doc/QFitsViewDoc.qrc
              resources/QFitsViewRes.qrc
	      QFitsView.rc
              )

IF(BISON_FOUND AND FLEX_FOUND)
add_dependencies(QFitsView patchMpfitParser)
add_dependencies(QFitsView patchMpfitScanner)
ENDIF()

# DEPENDENCIES: QT (SHARED | STATIC)
if (NOT BUILD_SHARED_LIBS)
  message("Statically linking to QT. Please note that a manual static compilation of Qt is required, otherwise dynamic libraries are used. Looking in ${QT_PATH}.")
endif()

set(QT_LIBRARIES PrintSupport Svg DataVisualization Network)

message("Included Qt libraries (please make sure that they are installed):")
foreach(library ${QT_LIBRARIES})
  message("* Qt${library}")
  target_link_libraries(QFitsView Qt::${library})
endforeach()

# DEPENDENCIES: SYSTEM LIBRARIES (SHARED | STATIC)

if(UNIX AND NOT APPLE)
    set(LINUX TRUE)
endif()

if (NOT LIB_PATH)
  if (WIN32)
    GET_FILENAME_COMPONENT(LIB_PATH "../lib/WIN64" ABSOLUTE)
	endif()
  if (APPLE)
    GET_FILENAME_COMPONENT(LIB_PATH "../lib/MACOS" ABSOLUTE)
	endif()
  if (LINUX)
    GET_FILENAME_COMPONENT(LIB_PATH "../lib/LINUX64" ABSOLUTE)
  endif()
endif()

if (NOT BUILD_SHARED_LIBS)
#  if (NOT LIB_PATH)
#    set(LIB_PATH "../lib/")
#  endif()

  message("Statically linking system libraries. Please note: Manual compilation of system libraries is required. Looking in ${LIB_PATH}.")
  target_link_libraries(QFitsView -static-libgcc -static-libstdc++ -static)
#  target_link_libraries(QFitsView -static)
#  set(CMAKE_EXE_LINKER_FLAGS "-static")
endif()

if (WIN32)
  target_link_libraries(QFitsView -static-libgcc -static-libstdc++ -static)
endif()

if (APPLE)
   set(app_icon_macos "${CMAKE_CURRENT_SOURCE_DIR}/resources/telescope.icns")
   set_source_files_properties(${app_icon_macos} PROPERTIES
           MACOSX_PACKAGE_LOCATION "Resources")

=== Makefile ===
################################################################################
# dpuser Makefile
################################################################################
# Type one of the following lines:
#   make                    same as 'make release'
#   make release            (static, 32/64-bit autodetect)
#   make release_shared     WIN only (shared, 32/64-bit autodetect)
#   make debug              (static, 32/64-bit autodetect)
#   make debug_shared       WIN only (shared, 32/64-bit autodetect)
#   make clean              to clean up the project
#   make revision           creates the revision-string
#   make dist               LINUX/MACOSX only to create a distribution as
#                           tar.gz-file, calls automatically the revision-target
#                           (do a checkout to a new location before, since all
#                           .svn-folders will be deleted!)
#
#
#   make parsers PLATFORM=LINUX (or MACOSX or WIN)
#                          to create just the parsers and lexxers for dpuser,
#                          dpuser2c & idl2c
#   make dpuser2c_header PLATFORM=LINUX (or MACOSX or WIN)
#                          to create just the dpuser2c.h-file
#
# In dpuser a static target means that all libraries and functionality is linked
# statically into the created binary.
# A shared target means that some dpuser-functionality is moved to a dll
# (external libraries are still linked statically).
#
################################################################################
RM          = rm -f
SED         = sed
CC          = gcc
CXX         = g++
LINK        = g++
QF          =
#GDL         = -DHAS_GDL
PY          = -DHAS_PYTHON

#PLPLOT      = -DHAS_PLPLOT
PGPLOT      = -DHAS_PGPLOT
DPPGPLOT    = -DHAS_DPPGPLOT
#PG2PLPLOT   = -DHAS_PG2PLPLOT

PLPLOTLIB   =
PGPLOTLIB   =

ifeq ($(PLPLOT), -DHAS_PLPLOT)
   PLPLOTLIB = -y
endif
ifeq ($(GDL), -DHAS_GDL)
   PLPLOTLIB = -y
endif
ifeq ($(PGPLOT), -DHAS_PGPLOT)
   ifeq ($(PG2PLPLOT), -DHAS_PG2PLPLOT)
      PLPLOTLIB = -y
      DPPGPLOT =
   else
      PGPLOTLIB = -y
   endif
endif

DEFINES     = $(PLPLOT) $(PGPLOT) $(DPPGPLOT) $(PG2PLPLOT) $(GDL) $(PY) -D$(OS)
ifeq ($(QF), -qt)
   DEFINES  += -DDPQT -DNO_READLINE
endif

CFLAGS      = -pipe -O2 -D_REENTRANT -w $(DEFINES)
CXXFLAGS    = -pipe -O2 -std=c++11 -Wno-narrowing -D_REENTRANT -w $(DEFINES)
INCPATH     = -I. -I../utils -I../libfits -I../include -Iparser -I.

ifeq ($(GDL), -DHAS_GDL)
   INCPATH  += -I../include/gdl
endif

OBJECTS =     dpuser_utils.o \
              dpuser.procs.o \
              helpmap.o \
              y.mpfit.o \
              mpfitAST.o \
              lex.mpfit.o \
              dpuserType.o \
              dpstring.o \
              dpstringlist.o \
              regex_sr.o \
              mpfit.o \
	            kabsch2d.o \
              3d_stuff.o \
              cube.o \
              dpheader.o \
              fits.o \
              fits_cube.o \
              fits_dpl.o \
              fits_exc.o \
              fits_file.o \
              fits_filters.o \
              fits_funcs.o \
              fits_mem.o \
              fits_ops.o \
              fits_procs.o \
              fits_range.o \
              fits_red.o \
              JulianDay.o \
              math_utils.o \
              dpComplex.o \
              fitting.o \
              voronoi.o \
              fits_logic.o \
              astrolib.o \
							arithmetics.o \
							boolean.o \
							dpuserAST.o \
              dpuser.yacchelper.o \
              functions.o \
              y.tab.o \
              dpuser.input.o \
              procedures.o \
              lex.yy.o \
              svn_revision.o \
							gdl_dpuser.o \
							python_dpuser.o \
							cpgplot.o \
							qtstubs.o

ifeq ($(PGPLOT), -DHAS_PGPLOT)
   ifeq ($(DPPGPLOT), -DHAS_DPPGPLOT)
      OBJECTS += cpg3d.o
   endif
endif

################################################################################
# Platform-specific defines

ifeq ($(HOMEDRIVE), C:)
   OS             = WIN
   RM             = del
   SED_INPLACE    = ../bin/WIN/sed.exe -i
   
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
   REV_NR := $(shell svnversion -c ..)
   $(shell @echo $(REV_NR) > _bbb.txt)
   REV_NR := $(shell sed -e 's/[MS]//g' -e 's/^[[:digit:]]*://' _bbb.txt)
   $(shell del _bbb.txt)

   ifndef $(ARCH)
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
      ARCH := $(shell wmic os get osarchitecture)
      $(shell @echo $(ARCH) > _bbb.txt)
      ARCH := $(shell sed  -e "s/OSArchitecture//g" -e "s/ //g" -e "s/-bit//g" -e "s/-Bit//g" _bbb.txt)
      $(shell del _bbb.txt)
   endif

   DEFINES  += -DHAVE_MINGW32

   LIBS =     ../lib/$(OS)$(ARCH)/libfftw3.a \
              ../lib/$(OS)$(ARCH)/libcpgplot.a \
              ../lib/$(OS)$(ARCH)/libpgplot.a \
              ../lib/$(OS)$(ARCH)/libpng.a \
              ../lib/$(OS)$(ARCH)/libxpa.a \
              ../lib/$(OS)$(ARCH)/libf2c.a \
              ../lib/$(OS)$(ARCH)/libreadline.a \
              ../lib/$(OS)$(ARCH)/libtermcap.a \
	      ../lib/$(OS)$(ARCH)/libcfitsio.a

   ifeq ($(GDL), -DHAS_GDL)
          LIBS  += ../lib/$(OS)$(ARCH)/libgdl.a \
                   ../lib/$(OS)$(ARCH)/libfftw3f.a \
                   ../lib/$(OS)$(ARCH)/libplplotcxx.a \
                   ../lib/$(OS)$(ARCH)/libplplot.a \
                   ../lib/$(OS)$(ARCH)/libqsastime.a \
                   ../lib/$(OS)$(ARCH)/libcsirocsa.a \
                   ../lib/$(OS)$(ARCH)/libgnurx.a \
                   ../lib/$(OS)$(ARCH)/libxdr.a \
                   -lole32 -lspoolss -lwinspool -loleaut32 -luuid
   endif
   ifeq ($(PY), -DHAS_PYTHON)
#      LIBS +=	/Programme/Python3/libs/libpython36.a
      INCPATH  += -I/Programme/Python3/include
   endif
       LIBS  += ../lib/$(OS)$(ARCH)/libgsl.a \
                ../lib/$(OS)$(ARCH)/libgslcblas.a \
								../lib/$(OS)$(ARCH)/libz.a \
                -lgdi32 -lws2_32 -lshlwapi -lcomdlg32 -lcomctl32
				 
   LDFLAG      = -static-libgcc -static-libstdc++ -static -Wl,--enable-runtime-pseudo-reloc
else
   REV_NR := $(shell svnversion -c .. | sed -e 's/[MS]//g' -e 's/^[[:digit:]]*://')

   ifeq ($(shell uname -m), x86_64)
      ARCH = 64
   else
      ARCH = 32
   endif

   ifeq ($(TERM_PROGRAM), Apple_Terminal)
      OS          = MACOSX
      ifeq ($(shell uname -m), arm64)
         ARCH = ARM64
      else
         ARCH = X64
      endif

      ifeq ($(ARCH), 32)
         LDFLAG      = -arch i386
         CXXFLAGS    := -arch i386 $(CXXFLAGS)
      else
         # -arch x86_64
         LDFLAG      = 
      endif
      SED_INPLACE = sed -i ''
      LIBS        = ../lib/MACOS$(ARCH)/libxpa.a \
                    ../lib/MACOS$(ARCH)/libfftw3.a \
                    ../lib/MACOS$(ARCH)/libcpgplot.a \
                    ../lib/MACOS$(ARCH)/libpgplot.a \
                    ../lib/MACOS$(ARCH)/libpng.a \
                    ../lib/MACOS$(ARCH)/libgsl.a \
                    ../lib/MACOS$(ARCH)/libgslcblas.a \
                    ../lib/MACOS$(ARCH)/libreadline.a \
                    ../lib/MACOS$(ARCH)/libcfitsio.a \
                    ../lib/MACOS$(ARCH)/libz.a \
                    ../lib/MACOS$(ARCH)/libncurses.a \
                    ../lib/MACOS$(ARCH)/libf2c.a
   ifeq ($(GDL), -DHAS_GDL)
            LIBS += ../lib/MACOS$(ARCH)/libgdl.a \
                    ../lib/MACOS$(ARCH)/libfftw3f.a \
                    ../lib/MACOS$(ARCH)/libplplot.a \
                    ../lib/MACOS$(ARCH)/libplplotcxx.a \
                    ../lib/MACOS$(ARCH)/libqsastime.a \
                    ../lib/MACOS$(ARCH)/libcsirocsa.a
   endif
      ifeq ($(ARCH), X64)
            LIBS += -L/opt/X11/lib \
                    -lX11
      endif
   ifeq ($(PY), -DHAS_PYTHON)
#            LIBS += -L/Library/Frameworks/Python.framework/Versions/3.6/lib -lpython3.6
#      INCPATH  += -I/Library/Frameworks/Python.framework/Versions/3.6/include/python3.6m -I/Library/Frameworks/Python.framework/Versions/3.6/lib/python3.6/site-packages/numpy/core/include
      INCPATH  += -I../include/$(OS)/python
#       -I/Library/Frameworks/Python.framework/Versions/3.6/lib/python3.6/site-packages/numpy/core/include
   endif

   else
      OS          = LINUX
      LDFLAG      = -static-libstdc++ -static-libgcc
      SED_INPLACE = sed -i''
      LIBS        = -rdynamic \
                    ../lib/$(OS)$(ARCH)/libxpa.a \
                    ../lib/$(OS)$(ARCH)/libfftw3.a \
                    ../lib/$(OS)$(ARCH)/libreadline.a \
                    ../lib/$(OS)$(ARCH)/libncurses.a
   ifeq ($(GDL), -DHAS_GDL)
          LIBS +=   ../lib/$(OS)$(ARCH)/libgdl.a
   endif
	 ifeq ($(PLPLOTLIB), -y)
          LIBS +=   ../lib/$(OS)$(ARCH)/libplplotcxx.a \
                    ../lib/$(OS)$(ARCH)/libfftw3f.a \
                    ../lib/$(OS)$(ARCH)/libplplot.a \
                    ../lib/$(OS)$(ARCH)/libqsastime.a
   endif
   ifeq ($(PGPLOTLIB), -y)
          LIBS +=   ../lib/$(OS)$(ARCH)/libcpgplot.a \
                    ../lib/$(OS)$(ARCH)/libpgplot.a \
                    ../lib/$(OS)$(ARCH)/libf2c.a
   endif
      LIBS +=   ../lib/$(OS)$(ARCH)/libgsl.a \
                ../lib/$(OS)$(ARCH)/libgslcblas.a \
                ../lib/$(OS)$(ARCH)/libcfitsio.a \
                ../lib/$(OS)$(ARCH)/libz.a \
                ../lib/$(OS)$(ARCH)/libpng.a
   ifeq ($(PY), -DHAS_PYTHON)
#      LIBS += /usr/lib/x86_64-linux-gnu/libpython3.5m.a -lexpat -lutil
      INCPATH  += -I/usr/include/python3.5m
   endif
       LIBS +=      -lX11 -ldl -lxcb -lpthread -lXdmcp -lXau

   endif
   TARDIR     := $(shell echo $(PWD) | sed 's|/dpuser$$||g' | sed 's|\/.*\/||g')
endif

################################################################################
# main targets
all: release 

##### RELEASE TARGETS #####
ifeq ($(OS), WIN) # start WIN
release:
	$(MAKE) static "TARGET_WIN = dpuser.exe"
else # start LINUX & MACOSX
release:
	$(MAKE) static "TARGET_LINUX = dpuser"
endif # end LINUX & MACOSX

##### DEBUG TARGETS #####
ifeq ($(OS), WIN) # start WIN
debug:
	$(MAKE) static "TARGET_WIN = dpuserD.exe" "CFLAGS = $(CFLAGS) -g -DDBG" "CXXFLAGS = $(CXXFLAGS) -g -DDBG"
else # start LINUX & MACOSX
debug:
	$(MAKE) static "TARGET_LINUX = dpuserD" "CFLAGS = $(CFLAGS) -g -DDBG" "CXXFLAGS = $(CXXFLAGS) -g -DDBG"
endif # end LINUX & MACOSX

################################################################################
# sub targets

ifeq ($(OS), WIN) # start WIN
static: revision parsers
	$(MAKE) $(MULTIPROZGEIL) $(TARGET_WIN)
else # end WIN, start LINUX & MACOSX
static: doc/helpmap.cpp revision parsers
	$(MAKE) $(MULTIPROZGEIL) $(TARGET_LINUX)
endif # end LINUX & MACOSX

$(TARGET_DLL): $(DLL_OBJECTS)
	g++ -shared -o $(TARGET_DLL) $(DLL_OBJECTS) $(DLL_LIBS)

$(TARGET_WIN): $(OBJECTS)
	$(LINK) $(LDFLAG) -o $(TARGET_WIN) $(OBJECTS) $(LIBS)

$(TARGET_LINUX): $(OBJECTS)
	$(LINK) $(LDFLAG) -o $(TARGET_LINUX) $(OBJECTS) $(LIBS)

# Builds parser-, dpuser2c & idl2c-source-files
parsers: parsers_qf
	$(MAKE) -C parser PLATFORM=$(OS)

parsers_qf:
	$(MAKE) -C mpfit PLATFORM=$(OS)

aux: revision parsers doc/helpmap.cpp

clean:
	-$(RM) $(OBJECTS)
	$(if $(OS:WIN=), \
		-$(RM) dpuser dpuserD \
	, \
		-$(RM) dpuser.exe dpuserD.exe \
	)
	

# this target is called by QFitsView 'make clean'
clean_qf: FORCE
	$(MAKE) -C parser clean  PLATFORM=$(OS)
	$(MAKE) -C mpfit clean PLATFORM=$(OS)

FORCE:

################################################################################
# Updates the revision in parser/svn_revision.h
revision:
ifeq ($(OS), WIN)
	echo #include "svn_revision.h" > parser/svn_revision.cpp
	echo. >> parser/svn_revision.cpp
	echo const char* GetRevString() { return "Rev. $(REV_NR)"; } >> parser/svn_revision.cpp
else
	@echo '#include "svn_revision.h"' > parser/svn_revision_new.cpp; \
	echo '' >> parser/svn_revision_new.cpp; \
	echo 'const char* GetRevString() { return "Rev. $(REV_NR)"; }' >> parser/svn_revision_new.cpp; \

=== cmpfit/Makefile ===

OFILES=mpfit.o
LIBFILE=libmpfit.a

all: $(LIBFILE) testmpfit

clean:
	rm -f $(OFILES) testmpfit $(LIBFILE)

mpfit.o: mpfit.c mpfit.h
	$(CC) -c -o $@ $< $(CFLAGS)

$(LIBFILE): $(OFILES)
	$(AR) r $@ $(OFILES)

testmpfit: testmpfit.c libmpfit.a
	$(CC) -o $@ $(CFLAGS) testmpfit.c -L. -lmpfit -lm

=== mpfit/Makefile ===
# mpfit-parser/lex Makefile
################################################################################

# Macros
MV         = mv
RM         = rm -f
SED        = sed
CP         = cp

ifeq ($(PLATFORM), WIN)
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
   ARCH := $(shell wmic os get osarchitecture)
   $(shell @echo $(ARCH) > _bbb.txt)
   ARCH := $(shell sed  -e "s/OSArchitecture//g" -e "s/ //g" -e "s/-bit//g" -e "s/-Bit//g" _bbb.txt)
   $(shell del _bbb.txt)

   YACC           = ..\..\bin\WIN$(ARCH)\yacc.exe
   LEX            = ..\..\bin\WIN$(ARCH)\flex.exe -i
   SED_INPLACE    = ..\..\bin\WIN$(ARCH)\sed.exe -i''
   MV             = ren
   RM             = del
	 CP             = copy /Y
  SED_STRING = $(SED_INPLACE) 's/file ? (isatty/0;\/\/file ? (isatty/g' lex.mpfit.cpp
else
   ifeq ($(shell uname -m), x86_64)
      ARCH = 64
   else
      ARCH = 32
   endif

   ifeq ($(PLATFORM), LINUX)
      YACC        = ../../bin/LINUX$(ARCH)/yacc
      LEX         = flex -l -i
      SED_INPLACE = sed -i''
   endif
   ifeq ($(PLATFORM), MACOSX)
      YACC        = yacc
      LEX         = flex -l -i
      SED_INPLACE = sed -i ''
   endif
   SED_STRING = $(SED_INPLACE) 's/extern int isatty/\/\/extern int isatty/g' lex.mpfit.cpp
endif

################################################################################
##### creates parser and lexer #####

mpfit-parser: y.mpfit.cpp lex.mpfit.cpp

y.mpfit.cpp: mpfit.y
	$(YACC) -d $<
	$(MV) y.tab.c y.mpfit.cpp

lex.mpfit.cpp: mpfit.l
	$(LEX) $<
	$(MV) lex.yy.c lex.mpfit.cpp

# all occurences of yy and YY are replaced with mpfit and MPFIT, because the lex.yy.cpp uses the same names -> error when linking
	$(SED_INPLACE) 's/yy/mpfit/g' y.mpfit.cpp lex.mpfit.cpp y.tab.h
	$(SED_INPLACE) 's/YY/MPFIT/g' y.mpfit.cpp lex.mpfit.cpp y.tab.h
# resolve the isatty problem (then-part= LINUX/MAC, else-part: WIN)
	$(SED_INPLACE) 's/extern int isatty/\/\/extern int isatty/g' lex.mpfit.cpp
	$(SED_STRING)
	
	$(MV) y.tab.h mpfitParser.h
#	$(CP) mpfitParser.h ..

clean:
	$(RM) y.mpfit.cpp lex.mpfit.cpp mpfitParser.h y.tab.c lex.yy.c

=== parser/Makefile ===
################################################################################
# dpuser-parser/lex Makefile
################################################################################

MV         = mv
RM         = rm -f
CP         = cp

ifeq ($(PLATFORM), WIN)
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
   ARCH := $(shell wmic os get osarchitecture)
   $(shell @echo $(ARCH) > _bbb.txt)
   ARCH := $(shell sed  -e "s/OSArchitecture//g" -e "s/ //g" -e "s/-bit//g" -e "s/-Bit//g" _bbb.txt)
   $(shell del _bbb.txt)

   YACC    = ..\..\bin\WIN$(ARCH)\yacc.exe
   LEX     = ..\..\bin\WIN$(ARCH)\flex.exe
   SED     = ..\..\bin\WIN$(ARCH)\sed.exe -i''
   MV      = ren
   RM      = del
	 CP      = copy /Y
else
   ifeq ($(shell uname -m), x86_64)
      ARCH = 64
   else
      ARCH = 32
   endif

   ifeq ($(PLATFORM), LINUX)
      YACC = ../../bin/LINUX$(ARCH)/yacc -d
      LEX  = flex -l
      SED  = sed -i''
   endif
   ifeq ($(PLATFORM), MACOSX)
      YACC = yacc
      LEX  = flex -l
      SED  = sed -i ''
   endif
endif

dpuser-parser: y.tab.cpp lex.yy.cpp

#y.tab.cpp: dpuser.y
y.tab.cpp: ast.y
	$(YACC) -d $<
	$(MV) y.tab.c y.tab.cpp

#lex.yy.cpp: dpuser.l
lex.yy.cpp: ast.l
	$(LEX) $<
	$(MV) lex.yy.c lex.yy.cpp
# resolve the isatty problem (only LINUX and MAC)
	$(if $(PLATFORM:WIN=), \
		$(SED) 's/extern int isatty/\/\/extern int isatty/g' lex.yy.cpp \
	)

	$(MV) y.tab.h astParser.h
#	$(CP) astParser.h ..

clean:
	$(RM) y.tab.cpp lex.yy.cpp astParser.h y.tab.c lex.yy.c svn_revision.cpp

=== debian/changelog ===
dpuser (4.2+dfsg-1) unstable; urgency=medium

  * New upstream version 4.2+dfsg
  * Rediff patches
  * Push Standards-Version to 4.7.0. No changes needed
  * Update d/copyright and d/clean for generated files
  * New build dependency libdfitsio-dev

 -- Ole Streicher <olebole@debian.org>  Sat, 05 Oct 2024 15:50:12 +0200

=== debian/control ===
Source: dpuser
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>
Section: science
Priority: optional
Build-Depends: bison,
               debhelper-compat (= 13),
               flex,
               giza-dev,
               libcfitsio-dev,
               libfftw3-dev,
               libgsl-dev,
               libpng-dev,
               libqt5datavisualization5-dev,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libqt5x11extras5-dev,
               libreadline-dev,
               libxpa-dev,
               qtbase5-dev,
               qtchooser,
               libz-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-astro-team/dpuser
Vcs-Git: https://salsa.debian.org/debian-astro-team/dpuser.git
Homepage: https://www.mpe.mpg.de/~ott/dpuser/index.html
Rules-Requires-Root: no

Package: dpuser
Architecture: any
Depends: g++,
         libc6-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: dpuser-doc
Description: Interactive language for handling numbers, strings, and matrices
 DPUSER is an interactive language capable of handling numbers (both real and
 complex), strings, and matrices. Its main aim is to do astronomical image
 analysis, for which it provides a comprehensive set of functions, but it can
 also be used for many other applications.
 .
 Note that this package was compiled with the giza library instead of PGPLOT,
 since the latter is non-free software.

Package: qfitsview
Architecture: any
Depends: g++,
         libc6-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: dpuser-doc
Description: FITS file viewer based on DPUSER
 QFitsView is a FITS file viewer based on DPUSER. In addition to displaying
 two-dimensional images, it also provides means to explore three-dimensional
 data cubes. It integrates the functionality of DPUSER which can be accessed
 directly out of QFitsView.
 .
 Note that this package was compiled with the giza library instead of PGPLOT,
 since the latter is non-free software.

Package: dpuser-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Documentation for DPUSER and QFitsView
 DPUSER is an interactive language capable of handling numbers (both real and
 complex), strings, and matrices. Its main aim is to do astronomical image
 analysis, for which it provides a comprehensive set of functions, but it can
 also be used for many other applications.
 .
 This package contains the documentation for DPUSER and QFitsView.

## dpuser 4.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -90,7 +90,7 @@
 if (NOT QT_PATH)
   if(WIN32)
     message("win32")
-    get_filename_component(QT_PATH "/Qt" ABSOLUTE)
+    get_filename_component(QT_PATH "/Qt/static" ABSOLUTE)
   elseif(APPLE)
     message("apple")
     get_filename_component(QT_PATH "/Users/ott/Qt/6.5.3/macos/lib/cmake/Qt6" ABSOLUTE)
@@ -142,8 +142,8 @@
 #@                  )
 
 # BISON & FLEX - uncomment if modifying the parsers
-#find_package(BISON 2.6)
-#find_package(FLEX 2.5)
+find_package(BISON 2.6)
+find_package(FLEX 2.6.4)
 
 # mpfit subdirectory
 IF(BISON_FOUND AND FLEX_FOUND)
@@ -195,7 +195,6 @@
    ${DPUSER_PATH}/python_dpuser.cpp
    ${DPUSER_PATH}/doc/helpmap.cpp
    ${DPUSER_PATH}/mpfit/mpfitAST.cpp
-   ${DPUSER_PATH}/parser/svn_revision.cpp
    )
 
 IF(BISON_FOUND AND FLEX_FOUND)
@@ -410,3 +409,5 @@
    set(app_icon_macos "${CMAKE_CURRENT_SOURCE_DIR}/resources/telescope.icns")
    set_source_files_properties(${app_icon_macos} PROPERTIES
            MACOSX_PACKAGE_LOCATION "Resources")
+   set_target_properties(QFitsView PROPERTIES
+      MACOSX_BUNDLE TRUE

=== Makefile ===
--- 
+++ 
@@ -8,9 +8,8 @@
 #   make debug              (static, 32/64-bit autodetect)
 #   make debug_shared       WIN only (shared, 32/64-bit autodetect)
 #   make clean              to clean up the project
-#   make revision           creates the revision-string
 #   make dist               LINUX/MACOSX only to create a distribution as
-#                           tar.gz-file, calls automatically the revision-target
+#                           tar.gz-file
 #                           (do a checkout to a new location before, since all
 #                           .svn-folders will be deleted!)
 #
@@ -115,7 +114,6 @@
               dpuser.input.o \
               procedures.o \
               lex.yy.o \
-              svn_revision.o \
 							gdl_dpuser.o \
 							python_dpuser.o \
 							cpgplot.o \
@@ -135,12 +133,6 @@
    RM             = del
    SED_INPLACE    = ../bin/WIN/sed.exe -i
    
-   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
-   REV_NR := $(shell svnversion -c ..)
-   $(shell @echo $(REV_NR) > _bbb.txt)
-   REV_NR := $(shell sed -e 's/[MS]//g' -e 's/^[[:digit:]]*://' _bbb.txt)
-   $(shell del _bbb.txt)
-
    ifndef $(ARCH)
    # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
       ARCH := $(shell wmic os get osarchitecture)
@@ -183,8 +175,6 @@
 				 
    LDFLAG      = -static-libgcc -static-libstdc++ -static -Wl,--enable-runtime-pseudo-reloc
 else
-   REV_NR := $(shell svnversion -c .. | sed -e 's/[MS]//g' -e 's/^[[:digit:]]*://')
-
    ifeq ($(shell uname -m), x86_64)
       ARCH = 64
    else
@@ -302,10 +292,10 @@
 # sub targets
 
 ifeq ($(OS), WIN) # start WIN
-static: revision parsers
+static: parsers
 	$(MAKE) $(MULTIPROZGEIL) $(TARGET_WIN)
 else # end WIN, start LINUX & MACOSX
-static: doc/helpmap.cpp revision parsers
+static: doc/helpmap.cpp parsers
 	$(MAKE) $(MULTIPROZGEIL) $(TARGET_LINUX)
 endif # end LINUX & MACOSX
 
@@ -325,7 +315,7 @@
 parsers_qf:
 	$(MAKE) -C mpfit PLATFORM=$(OS)
 
-aux: revision parsers doc/helpmap.cpp
+aux: parsers doc/helpmap.cpp
 
 clean:
 	-$(RM) $(OBJECTS)
@@ -343,14 +333,30 @@
 
 FORCE:
 
-################################################################################
-# Updates the revision in parser/svn_revision.h
-revision:
-ifeq ($(OS), WIN)
-	echo #include "svn_revision.h" > parser/svn_revision.cpp
-	echo. >> parser/svn_revision.cpp
-	echo const char* GetRevString() { return "Rev. $(REV_NR)"; } >> parser/svn_revision.cpp
-else
-	@echo '#include "svn_revision.h"' > parser/svn_revision_new.cpp; \
-	echo '' >> parser/svn_revision_new.cpp; \
-	echo 'const char* GetRevString() { return "Rev. $(REV_NR)"; }' >> parser/svn_revision_new.cpp; \
+
+################################################################################
+# Creates a distribution
+ifeq ($(OS), WIN) # start WIN
+dist:
+	@echo "*************************************************************"
+	@echo "ERROR: Distribution can only be generated under LINUX or MAC!"
+	@echo "*************************************************************"
+else # end WIN, start LINUX & MACOSX
+dist: clean
+	cd ../QFitsView && make -i clean
+	find .. -type d -name ".svn" -exec rm -rf {} +
+	find .. -type d -name "obsolete" -exec rm -rf {} +
+	find .. -regextype posix-extended -regex '.*\.(a|lib|dll|exe)' -exec rm {} +
+	rm -rf ../include/*
+	rm -rf ../bin/*
+	rm -rf ../external/*z
+	tar cfvz ../../dpuser.tar.gz ../../$(TARDIR)
+endif # end LINUX & MACOSX
+
+################################################################################
+# Compile rules
+dpuser.o:              dpuser.cpp \
+                       dpuser.h \
+                       dpuser.yacchelper.h \
+                       dpuser.procs.h \
+                       procedures.h \

=== mpfit/CMakeLists.txt ===
find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)

BISON_TARGET(mpfity mpfit.y "${CMAKE_CURRENT_BINARY_DIR}/y.mpfit.c")
FLEX_TARGET(mpfitl mpfit.l "${CMAKE_CURRENT_BINARY_DIR}/lex.mpfit.c")
ADD_FLEX_BISON_DEPENDENCY(mpfitl mpfity)

=== parser/CMakeLists.txt ===
find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)

BISON_TARGET(parsery ast.y "${CMAKE_CURRENT_BINARY_DIR}/y.ast.c")
FLEX_TARGET(parserl ast.l "${CMAKE_CURRENT_BINARY_DIR}/lex.ast.c")
ADD_FLEX_BISON_DEPENDENCY(parserl parsery)

=== debian/changelog ===
dpuser (4.3+dfsg-1) unstable; urgency=medium

  * New upstream version 4.3+dfsg
  * Rediff patches
  * Replace virtual package libz-dev with zlib1g-dev
  * Push Standards-Version to 4.7.2, no changes needed

 -- Ole Streicher <olebole@debian.org>  Mon, 17 Mar 2025 13:27:46 +0100

=== debian/control ===
--- 
+++ 
@@ -19,8 +19,8 @@
                libxpa-dev,
                qtbase5-dev,
                qtchooser,
-               libz-dev
-Standards-Version: 4.7.0
+               zlib1g-dev
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/dpuser
 Vcs-Git: https://salsa.debian.org/debian-astro-team/dpuser.git
 Homepage: https://www.mpe.mpg.de/~ott/dpuser/index.html

=== debian/tests/control ===
Tests: testsuite
Depends: dpuser
